/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 184 by dpavlin, Tue Mar 16 20:42:38 2010 UTC revision 236 by dpavlin, Wed Jan 26 12:16:23 2011 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47  }  }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54    }
55    
56  lxc_status() {  lxc_status() {
57          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
58                  on_boot="       "                  boot="-"
59                  test -s /var/lib/lxc/$name/on_boot && on_boot="on_boot"                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
60                  echo "$name $status $on_boot $(lxc_rootfs $name)"                  echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
61          done          done ) | column -t
62  }  }
63    
64    
# Line 50  cleanup_init_scripts() { Line 66  cleanup_init_scripts() {
66          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
67    
68          ls \          ls \
69                    $rootfs/etc/rc?.d/*checkroot* \
70                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
71                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
72                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
73                    $rootfs/etc/rc?.d/*udev* \
74          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
75    
76            echo $1 > $rootfs/etc/hostname
77            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
78  }  }
79    
80    
# Line 64  setup_inittab() { Line 85  setup_inittab() {
85    
86          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
87          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
88          if ! grep "$add" ${inittab} >/dev/null ; then          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
89                  grep -v "$remove" ${inittab} > ${inittab}.new                  grep -v "$remove" ${inittab} > ${inittab}.new
90                  echo $add >> ${inittab}.new                  echo $add >> ${inittab}.new
91                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
# Line 73  setup_inittab() { Line 94  setup_inittab() {
94  }  }
95    
96    
97    lxc_log() {
98            echo `date +%Y-%m-%dT%H:%M:%S` $*
99    }
100    
101    
102  lxc_kill() {  lxc_kill() {
103          name=$1          name=$1
104          sig=$2          sig=$2
# Line 82  lxc_kill() { Line 108  lxc_kill() {
108                  lxc-info -n $name                  lxc-info -n $name
109                  exit 1                  exit 1
110          fi          fi
111          echo "$name kill $sig $init_pid"          lxc_log "$name kill $sig $init_pid"
112          /bin/kill $sig $init_pid          /bin/kill $sig $init_pid
113  }  }
114    
115  lxc_stop() {  lxc_stop() {
116            lxc_log "$name stop"
117          lxc_kill $name -SIGPWR          lxc_kill $name -SIGPWR
118          lxc-wait -n $name -s STOPPED          lxc-wait -n $name -s STOPPED
119            lxc_log "$name stoped"
120  #       rm -f /var/lib/lxc/${name}/on_boot  #       rm -f /var/lib/lxc/${name}/on_boot
121  }  }
122    
123    
124  lxc_start() {  lxc_start() {
125          name=$1          name=$1
126            rootfs=$(lxc_rootfs $1)
127    
128            if [ ! -e $rootfs ] ; then
129                    echo "ERROR $name rootfs $rootfs not found"
130                    return
131            fi
132    
133          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
134                  echo "$name start"                  lxc_log "$name start"
135                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
136                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
137                  lxc-info  -n $name                  lxc-info  -n $name
138                  echo $name > /var/lib/lxc/${name}/on_boot                  test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
139          fi          fi
140  }  }
141    
# Line 112  rootfs=$(lxc_rootfs $1) Line 146  rootfs=$(lxc_rootfs $1)
146  while true; do  while true; do
147          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
148          tasks=`wc -l < /cgroup/${name}/tasks`          tasks=`wc -l < /cgroup/${name}/tasks`
149            stop_on=1 # init
150            sulogins=`lxc-ps --name backuppc | grep sulogin | wc -l`
151            if [ "$sulogins" -gt 0 ] ; then
152                    stop_on=`expr $stop_on + $sulogins`
153            fi
154    
155          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
156          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq $stop_on ]; then
157    
158                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
159                  echo `date +%Y-%m-%dT%H:%M:%S` "$name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
160    
161                  case $runlevel in                  case $runlevel in
162                  N*)                  N*)
163                          # nothing for new boot state                          # nothing for new boot state
164                  ;;                  ;;
165                  ??0)                  ??0)
166                          echo "$name halt"                          lxc_log "$name halt"
167                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
168                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
169                          break                          break
170                  ;;                  ;;
171                  ??6)                  ??6)
172                          echo "$name reboot";                          lxc_log "$name reboot";
173                          lxc-stop -n ${name}                          lxc-stop -n ${name}
174                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
175                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
# Line 141  while true; do Line 181  while true; do
181                  ;;                  ;;
182                  esac                  esac
183          else          else
184                  echo "# $name $tasks tasks"                  lxc_log "$name $tasks tasks $sulogins console"
185          fi          fi
186    
187          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...
188          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 ${vps_utmp}
189  done  done
190    
191  echo "${name} exited"  lxc_log "$name watchdog exited"
192    
193  }  }
194    
195    
196    usage() {
197            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
198            exit 3
199    }
200    
201  command_on_lxc() {  command_on_lxc() {
202  command=$1  command=$1
203  shift  shift
# Line 164  case "$command" in Line 209  case "$command" in
209  start)  start)
210          lxc_exists $1          lxc_exists $1
211          cleanup_init_scripts $1          cleanup_init_scripts $1
212          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
213          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
214            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
215          lxc_start $1          lxc_start $1
216          ( nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          # give container 5 seconds to start more than one process
217            ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
218          ;;          ;;
219  stop|halt)  stop|halt)
220          lxc_exists $1          lxc_exists $1
# Line 179  reload|force-reload|restart|reboot) Line 226  reload|force-reload|restart|reboot)
226  watchdog)  watchdog)
227          lxc_watchdog $1          lxc_watchdog $1
228          ;;          ;;
229    boot)
230            echo $1 > /var/lib/lxc/$1/on_boot
231            ;;
232    disable)
233            echo -n > /var/lib/lxc/$1/on_boot
234            ;;
235  *)  *)
236          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
237          ;;          ;;
238    
239  esac  esac
# Line 189  esac Line 241  esac
241  }  }
242    
243  command=$1  command=$1
244  shift  test -z "$command" && usage
   
245  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
246    shift
247    
248  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
249          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do
250                  name=`echo $path | cut -d/ -f5`                  name=`echo $path | cut -d/ -f5`
251                  command_on_lxc $command $name                  if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
252                            command_on_lxc $command $name
253                    else
254                            echo "# skip $command $name"
255                    fi
256          done          done
257  else  else
258          while [ ! -z "$1" ] ; do          while [ ! -z "$1" ] ; do

Legend:
Removed from v.184  
changed lines
  Added in v.236

  ViewVC Help
Powered by ViewVC 1.1.26